import java.util.HashMap;
import java.util.Map;

class CountWords {

static Tokenizer t;

public static void main(String[] args) {
    String filename = "tiny.text";
    // filename = "wirth.text";
    // filename = "spacedoctor.text";
    if (args.length >= 1) filename = args[0];
    System.out.println("filename: " + filename);
    t = new Tokenizer(filename);
    /* */
    HashMap<String,Integer> d = new HashMap<String,Integer>();
    //HashDict d = new HashDict();

    String word = getword();
    while (word != null) {
	    //System.out.println(word);
    	if (d.containsKey(word)) {
    	    int c = d.get(word);
    	    d.put(word,c+1);
    	} else {
    	    d.put(word,1);
    	}
    	word = getword();
    }
    // this is arcane, but you'll use d.print() for HashDict.
    //d.print();
    int wcount = 0;
    for (Map.Entry<String,Integer> entry : d.entrySet()) {
        System.out.printf("%s:  %d%n", entry.getKey(), entry.getValue());
        wcount++;
    }
    System.out.printf("there were %d distinct words in all", wcount);
    // you will use: d.Print();
    
}

public static String getword() {
    String word;
    do {
	    word = t.token();
    } while (word != null && (word.equals("ILLEGAL TOKEN") || !Character.isLetter(word.charAt(0))));
    if (word==null) return null;
    else return word.toLowerCase();
}

}